% Num. Math. - FS 2014 - Serie 3 Uebung 3 - Explicit Euler method

function s3_3_Euler
format long
f1=@(t,x) -0.5*x;
f2=@(t,x) t.^2+x;

h_vec=10.^(-(1:3)); %Schrittweiten
% Endzeiten:
tf1=1;
tf2=[0.5 2 4];

%Referenzloesungen
x1_ref=exp(-0.5*tf1')     % exakte Werte fuer 
% die Loesung x(tf) von der ODE von a). 
x2_ref= exp(tf2)-tf2.^2-2*tf2-2     % exakter Wert fuer 
% die Loesung x(tf) von der ODE von b). 


x1_eul=zeros(1,length(h_vec));
x1_err=x1_eul;
x2_eul=zeros(length(tf2),length(h_vec));
x2_err=x2_eul;
for i=1:length(h_vec)
    x1_eul(i)=exp_euler(0,1,f1,h_vec(i),tf1/h_vec(i));
    x1_err(i)=abs(x1_eul(i)-x1_ref); 
    for j=1:length(tf2)
        x2_eul(j,i)=exp_euler(0,-1,f2,h_vec(i),tf2(j)/h_vec(i));
        x2_err(j,i)=abs(x2_eul(j,i)-x2_ref(j));   
    end
end
x1_eul
x2_eul
x1_err
x2_err
end


% exp_euler solves the ODE with Euler method:
% t0    initial time
% x0    initial value
% fct   ODE function
% h     mesh size = length of each step
% n     number of steps to do
%
% x is the approximation of the value of the solution of the ODE in to+h*n

function[x]=exp_euler(t0,x0,fct,h,n)
   x=x0;
   for k=1:n
       x=x+h*fct((k-1)*h+t0,x);
   end
end
