% Num. Math. - FS 2014 - Serie 3 Uebung 3 - Heun method

function s3_3_Heun
format long
f1=@(t,x) -0.5*x;
f2=@(t,x) t.^2+x;

h_vec=10.^(-(1:3)); %Schrittweiten
% Endzeiten:
tf1=1;
tf2=[0.5 2 4];

%Referenzloesungen
x1_ref=exp(-0.5*tf1')     % exakte Werte fuer 
% die Loesung x(tf) von der ODE von a). 
x2_ref=exp(tf2)-tf2.^2-2*tf2-2     % exakter Wert fuer 
% die Loesung x(tf) von der ODE von b). 


x1_heun=zeros(1,length(h_vec));
x1_err=x1_heun;
x2_heun=zeros(length(tf2),length(h_vec));
x2_err=x2_heun;
for i=1:length(h_vec)
    x1_heun(i)=heun(0,1,f1,h_vec(i),tf1/h_vec(i));
    x1_err(i)=abs(x1_heun(i)-x1_ref); 
    for j=1:length(tf2)
        x2_heun(j,i)=heun(0,-1,f2,h_vec(i),tf2(j)/h_vec(i));
        x2_err(j,i)=abs(x2_heun(j,i)-x2_ref(j));   
    end
end
x1_heun
x2_heun
x1_err
x2_err
end

% heun solves the ODE with Heun method:
% t0    initial time
% x0    initial value
% fct   ODE function
% h     mesh size = length of each step
% n     number of steps to do
%
% x is the approximation of the value of the solution of the ODE in to+h*n

function[x]=heun(t0,x0,fct,h,n)
   x=x0;
   for k=1:n
       k1 = fct(t0+(k-1)*h,x);
       k2 = fct(t0+k*h,x+h*k1);
       x=x + 0.5*h*(k1 + k2);
   end
end
