% Num. Math. - FS 2014 - Serie 3 Uebung 4 - Taylormethode

function s3_4_Taylor
format long
f=@(t,x)sin(x)+t.^2;

h_vec=10.^(-[1:3]); %Schrittweiten
% Endzeiten:
tf=1;

%Referenzloesungen
[T,X] = ode45(f,[0,tf],1);
x_ref=X(end)     % exakte Werte fuer 
% die Loesung x(tf) von der ODE von a). 


x_tay=zeros(length(tf),length(h_vec));
x_err=x_tay;
for i=1:length(h_vec)
    x_tay(i)=taylor(0,1,f,h_vec(i),tf/h_vec(i));
    x_err(i)=abs(x_tay(i)-x_ref);   
end
x_tay
x_err
end


% taylor solves the ODE with Taylor method:
% t0    initial time
% x0    initial value
% fct   ODE function
% h     mesh size = length of each step
% n     number of steps to do
%
% x is the approximation of the value of the solution of the ODE in to+h*n

function[x]=taylor(t0,x0,fct,h,n)
   x=x0;
   t=t0;
   for k=1:n
       x=x+h*(sin(x)+t^2)+...
           (2*t+cos(x)*(sin(x)+t^2))*h^2/2 ...
       +(2-sin(x)*(sin(x)+t^2)^2+cos(x)*(2*t+cos(x)*(sin(x)+t^2)))*h^3/6;
       t=t+h;
   end
end
